<html>
<head>
<title>OgreArchive.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreArchive.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreArchive_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _Archive_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _Archive_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreDataStream_8h.html">OgreDataStream.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreStringVector_8h.html">OgreStringVector.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreException_8h.html">OgreException.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &lt;ctime&gt;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre {
<a name="l00040"></a>00040 
<a name="l00052"></a><a class="code" href="structOgre_1_1FileInfo.html">00052</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1FileInfo.html" title="Information about a file/directory within the archive will be returned using a FileInfo struct...">FileInfo</a> {
<a name="l00055"></a><a class="code" href="structOgre_1_1FileInfo.html#a60434fe6c87df669188d79633ddc73c6">00055</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a>* <a class="code" href="structOgre_1_1FileInfo.html#a60434fe6c87df669188d79633ddc73c6" title="The archive in which the file has been found (for info when performing multi-Archive searches...">archive</a>;
<a name="l00057"></a><a class="code" href="structOgre_1_1FileInfo.html#a841227629a26a422c3ba6c4bd1877d62">00057</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1FileInfo.html#a841227629a26a422c3ba6c4bd1877d62" title="The file&#39;s fully qualified name.">filename</a>;
<a name="l00059"></a><a class="code" href="structOgre_1_1FileInfo.html#ad2e54ca7979d9c87a255e6eb532a33f2">00059</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1FileInfo.html#ad2e54ca7979d9c87a255e6eb532a33f2" title="Path name; separated by &#39;/&#39; and ending with &#39;/&#39;.">path</a>;
<a name="l00061"></a><a class="code" href="structOgre_1_1FileInfo.html#ac48eca5413e87a3efd1f3355b994f5fd">00061</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1FileInfo.html#ac48eca5413e87a3efd1f3355b994f5fd" title="Base filename.">basename</a>;
<a name="l00063"></a><a class="code" href="structOgre_1_1FileInfo.html#ac9634cdb326f2b11575a8cc7fc509b96">00063</a>         <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1FileInfo.html#ac9634cdb326f2b11575a8cc7fc509b96" title="Compressed size.">compressedSize</a>;
<a name="l00065"></a><a class="code" href="structOgre_1_1FileInfo.html#a66c7bf4f59feb619016a5c70e4ded4ee">00065</a>         <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1FileInfo.html#a66c7bf4f59feb619016a5c70e4ded4ee" title="Uncompressed size.">uncompressedSize</a>;
<a name="l00066"></a>00066     };
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="group__Resources.html#ga80f17ac4d148a831fe015742d56727f9">00068</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;FileInfo&gt;::type</a> <a class="code" href="group__Resources.html#ga80f17ac4d148a831fe015742d56727f9">FileInfoList</a>;
<a name="l00069"></a><a class="code" href="group__Resources.html#ga98a851530d714bac278ff907738ac643">00069</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;FileInfoList&gt;</a> <a class="code" href="group__Resources.html#ga98a851530d714bac278ff907738ac643">FileInfoListPtr</a>;
<a name="l00070"></a>00070 
<a name="l00087"></a><a class="code" href="classOgre_1_1Archive.html">00087</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ArchiveAlloc</a>
<a name="l00088"></a>00088     {
<a name="l00089"></a>00089     <span class="keyword">protected</span>:
<a name="l00091"></a><a class="code" href="classOgre_1_1Archive.html#ab1e42e1a419b26b1b7c6f26b77dde5a3">00091</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Archive.html#ab1e42e1a419b26b1b7c6f26b77dde5a3" title="Archive name.">mName</a>; 
<a name="l00093"></a><a class="code" href="classOgre_1_1Archive.html#abf7ba39bebb760ce55d517aa289096fb">00093</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Archive.html#abf7ba39bebb760ce55d517aa289096fb" title="Archive type code.">mType</a>;
<a name="l00095"></a><a class="code" href="classOgre_1_1Archive.html#ad85bb767e01c492075ec5291c1b9f5c4">00095</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Archive.html#ad85bb767e01c492075ec5291c1b9f5c4" title="Read-only flag.">mReadOnly</a>;
<a name="l00096"></a>00096     <span class="keyword">public</span>:
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00101"></a><a class="code" href="classOgre_1_1Archive.html#aa527675b915110919a754a226feebc4f">00101</a>         <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; archType )
<a name="l00102"></a>00102             : mName(name), mType(archType), mReadOnly(true) {}
<a name="l00103"></a>00103 
<a name="l00106"></a><a class="code" href="classOgre_1_1Archive.html#a370fba29d752fa317e992aec6625d5ed">00106</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Archive.html#a370fba29d752fa317e992aec6625d5ed" title="Default destructor.">~Archive</a>() {}
<a name="l00107"></a>00107 
<a name="l00109"></a><a class="code" href="classOgre_1_1Archive.html#aa4860f997861f44b61a436d55cdcc66b">00109</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1Archive.html#aa4860f997861f44b61a436d55cdcc66b" title="Get the name of this archive.">getName</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00110"></a>00110 
<a name="l00112"></a>00112         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isCaseSensitive(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00113"></a>00113 
<a name="l00121"></a>00121         <span class="keyword">virtual</span> <span class="keywordtype">void</span> load() = 0;
<a name="l00122"></a>00122 
<a name="l00128"></a>00128         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unload() = 0;
<a name="l00129"></a>00129 
<a name="l00133"></a><a class="code" href="classOgre_1_1Archive.html#aac59f4ba4e35fe3bf8820117593d0998">00133</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Archive.html#aac59f4ba4e35fe3bf8820117593d0998" title="Reports whether this Archive is read-only, or whether the contents can be updated.">isReadOnly</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mReadOnly; }
<a name="l00134"></a>00134 
<a name="l00146"></a>00146         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> open(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename, <span class="keywordtype">bool</span> readOnly = <span class="keyword">true</span>) <span class="keyword">const</span> = 0;
<a name="l00147"></a>00147 
<a name="l00154"></a><a class="code" href="classOgre_1_1Archive.html#a89cb3f2063d3d1920f2deac1934b3c22">00154</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> create(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename)<span class="keyword"> const</span>
<a name="l00155"></a>00155 <span class="keyword">        </span>{
<a name="l00156"></a>00156                         (void)filename;
<a name="l00157"></a>00157             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, 
<a name="l00158"></a>00158                 <span class="stringliteral">&quot;This archive does not support creation of files.&quot;</span>, 
<a name="l00159"></a>00159                 <span class="stringliteral">&quot;Archive::create&quot;</span>);
<a name="l00160"></a>00160         }
<a name="l00161"></a>00161 
<a name="l00166"></a><a class="code" href="classOgre_1_1Archive.html#af0144235a0da9fe837138c7482e2b7aa">00166</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <span class="keyword">remove</span>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename) <span class="keyword">const</span>
<a name="l00167"></a>00167         {
<a name="l00168"></a>00168                         (void)filename;
<a name="l00169"></a>00169             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, 
<a name="l00170"></a>00170                 <span class="stringliteral">&quot;This archive does not support removal of files.&quot;</span>, 
<a name="l00171"></a>00171                 <span class="stringliteral">&quot;Archive::remove&quot;</span>);
<a name="l00172"></a>00172         }
<a name="l00173"></a>00173 
<a name="l00184"></a>00184         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">StringVectorPtr</a> <a class="code" href="structOgre_1_1list.html">list</a>(<span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>, <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>) = 0;
<a name="l00185"></a>00185         
<a name="l00194"></a>00194         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">FileInfoListPtr</a> listFileInfo(<span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>, <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>) = 0;
<a name="l00195"></a>00195 
<a name="l00208"></a>00208         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">StringVectorPtr</a> find(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, <span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>,
<a name="l00209"></a>00209             <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>) = 0;
<a name="l00210"></a>00210 
<a name="l00212"></a>00212         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> exists(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename) = 0; 
<a name="l00213"></a>00213 
<a name="l00215"></a>00215         <span class="keyword">virtual</span> time_t getModifiedTime(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename) = 0; 
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00228"></a>00228         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">FileInfoListPtr</a> findFileInfo(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, 
<a name="l00229"></a>00229             <span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>, <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>) <span class="keyword">const</span> = 0;
<a name="l00230"></a>00230 
<a name="l00232"></a><a class="code" href="classOgre_1_1Archive.html#ab0fe79a8deba20a1cc1301f68805b621">00232</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1Archive.html#ab0fe79a8deba20a1cc1301f68805b621" title="Return the type code of this Archive.">getType</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mType; }
<a name="l00233"></a>00233         
<a name="l00234"></a>00234     };
<a name="l00238"></a>00238 }
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
